#include "header/trefreshmap.h"

using namespace std;

// Esta rotina sera executada quando for chamada a funcao CreateThread
void *TRefreshMap::ThreadEntryRoutine(gxThread_t *thread)
{
	printf("Entering Trefreshmap...\n");

	while(continua)
	{
		makeMap->refreshMap(posx, posy);
		mSleep(500);

	}
}

void TRefreshMap::ThreadExitRoutine(gxThread_t *thread)
{
	printf("Exiting Trefreshmap...\n");
	makeMap->finishThread();

}


void TRefreshMap::setMakemap(MakeMap *map, int x, int y)
{
	continua = true;
	makeMap = map;
	posx = x;
	posy = y;
}

void TRefreshMap::setContinua(bool cont)
{
	continua = cont;
}






