package navmap;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;

/**
 * Classe que mostra a tela com as informaoes sobre a Aplicaao
 * Title:        NavMap
 * Description:  Navegao por Mapeamento
 * Copyright:    Copyright (c) 2002
 * Company:      Graco - UnB
 * @author Marcio Moreira de Sousa e Paulo Roberto Corra Dutra
 * @version 1.0
 */

public class TelaSobre extends JFrame{

 private JLabel lbSobre = new JLabel();
 private JPanel PanelSobre = new JPanel();
 private TitledBorder titledBorder1;
  private JButton jButton1 = new JButton();

 public TelaSobre() {


    try{
      jbInit();
    }catch(Exception ex){
      ex.printStackTrace();
    }

  }

  private void jbInit() throws Exception{

    titledBorder1 = new TitledBorder(BorderFactory.createEtchedBorder(Color.white,new Color(148, 145, 140)),"NavMap - Navegacao por mapeamento");
    PanelSobre.setBorder(titledBorder1);

    PanelSobre.setLayout(null);

    lbSobre.setText("<HTML> Projeto final de Graduacao <BR>" +
    "Copyright(c) NavMap 2002-2003 <BR>" +
    "Programadores:<BR>"+
     "<UL>"+
     "<LI> Marcio Moreira de Sousa"+
     "<LI> Paulo Roberto Correa Dutra"+
     "</UL>"
     +"<HTML>");

    lbSobre.setVerticalAlignment(SwingConstants.TOP);
    lbSobre.setVerticalTextPosition(SwingConstants.TOP);

    lbSobre.setBounds(new Rectangle(17, 40, 352, 137));


    jButton1.setText("OK");
    jButton1.setBounds(new Rectangle(105, 227, 84, 21));
    jButton1.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        dispose();
        //jButton1_actionPerformed(e);
      }
    });
    this.getContentPane().add(PanelSobre, null);
    PanelSobre.add(lbSobre, null);
    PanelSobre.add(jButton1, null);
    this.setTitle("Sobre o NavMap");


    this.addWindowListener(new java.awt.event.WindowAdapter() {
      public void windowClosing(WindowEvent we){
        dispose();
      }
    });

  }
}

