/* Programa para envio e recebimento de Telegramas do ROBO ABBIRB 2000 */
/* Leitura do Telegrama feita por arquivo */

#include<stdio.h>
#include<fcntl.h>
#include<stdlib.h>
#include<termios.h>
#include<errno.h>
#include<time.h>

#define ENQ 0x05
#define ACK 0x06
#define WACK 0x0E
#define RVI 0x0F
#define NAK 0x15
#define DLE 0x10
#define STXeven 0x02
#define STXodd 0x82
#define ETX 0x03
#define EOT 0x04

#define BAUDRATE B9600
#define MODEMDEVICE "/dev/ttyS1"
#define TRUE 1
#define FALSE 0

FILE *fptr;

main()
{
int fd, NOB, i,j,k,l, coderro, numofteleg, MessageSize;
struct termios oldtio, newtio, oldstdtio, newstdtio;
unsigned char STXevenTX, STXevenRX, Byte_TX, Byte_RX, BCS, Cabecalho[7],
Telegram_TX[129], Telegram_RX[129], erro,
STX;
time_t TimeSec;

erro = false;
STXevenTX = TRUE;
STXevenRX = TRUE;
/* Faz-se a leitura e montagem do Telegrama do Arquivo */

fptr = fopen("/home/paulinyi/ROBO/telegrama.txt","r");
fscanf(fptr,"%s",MessageSize); /* le a primeira linha do arquivo */
l=2;
while (l>1)
   {
    l = MessageSize/128;
    MessageSize = MessageSize - 120;
    numofteleg = numofteleg +1
   }
for (i=0, i<6, i++)
fscanf(fptr,"%s",Cabecalho[i+1]);

/* Abertura da Porta Serial do Computador */

fd = open (MODEMDEVICE, O_RDWR | O_NOCTTY);
if (fd<0)
   {
    perror(MODEMDEVICE);
    exit(-1);
    erro = true;
    coderro=1;
   }
tcgetattr(fd,&oldtio);
newtio.c_cflag = BAUDRATE | CRTSCTS | CS8 | PARENB | CLOCAL | CREAD;
newtio.c_iflag = IGNPAR;
newtio.c_oflag = 0;
newtio.c_lflag = 0;
newtio.c_cc[VMIN]=1;
newtio.c_cc[VTIME]=0;
tcflush(fd,TCIFLUSH);
tcsetattr(fd,TCSANOW,&newtio);
tcsetattr(1,TCSANOW,&newtio);
tcgetattr(0,&oldstdio);
tcgetattr(0,&newstdtio);
newstdtio.c_lflag &= ~(ICANON | ECHO);
tcsetattr(0,TCSANOW,&newstdtio);


/* FASE 1 TRANSMISSAO */
if (erro == FALSE)
   {

    /* Envia o ENQ */
    Byte_TX=ENQ;
    write(fd,&Byte_TX,1);

    /* Recebe a resposta do Robo */
    read(fd,&Byte_RX,1);
    if (Byte_RX != ACK)
      {
       if (Byte_RX == ENQ)
          {
           read(fd,&Byte_RX,1);
           if (Byte_RX != ACK)
              {
               erro=TRUE;
               coderro = 2;
              }
          }
       else erro=TRUE;
       coderro = 2;
      }
   }

/* FASE 1 TERMINADA - CONTATO ESTABELECIDO */

/* FASE 2 TRANSMISSAO DO TELEGRAMA */
 
if (erro == FALSE)
   {
    for (j = 0; j < numofteleg; j++);
      {
       NOB = Telegram_TX[0] * 0x100 + Telegram_TX[1];
       if (STXevenTX == TRUE) STX = STXeven else STX = STXodd;
    
       /* Calculo do BCS */
       for (i=0; i< NOB; i++) 
       BCS = BCS ^ Telegram_TX[i];
       BCS = BCS ^ ETX;

       /* Caracteres de controle do inicio do telegrama */
       Byte_TX=DLE;
       write(fd,&Byte_TX,1);
       Byte_TX=STX;
       write(fd,&Byte_TX,1);

       /* Envia telegrama */
       for (i = 0; i < NOB; i++);
          { 
           if (Telegram_TX[i] == DLE)
              {
               Byte_TX = DLE;
               write(fd,&Byte_TX,1);
              }
           Byte_TX = Telegram_TX[i];
           write(fd,&Byte_TX,1);
          }

       /* caracteres de  fim de telegrama */
       Byte_TX=DLE;
       write(fd,&Byte_TX,1);
       Byte_TX=ETX;
       write(fd,&Byte_TX,1);
       Byte_TX=BCS;
       write(fd,&Byte_TX,1);

       read(fd,&Byte_RX,1);
       if (Byte_RX = ACK)
          {
           STXevenTX = !(STXevenTX)
          }
       if (Byte_RX = NAK);
          {
           j = j -1;
          }
      }
   }

/* FASE 2 TERMINADA - TELEGRAMAS TRANSMITIDOS */

/* FASE 3 - ENCERRAMENTO DO ENVIO DE DADOS */

if (erro == FALSE)
   {
    Byte_TX = EOT;
    write(fd,&Byte_TX,1);
   }

/* FASE 1 - INICIO DA RECEPCAO */

if (erro == FALSE)
   {
    read(fd,&Byte_RX,1);
    if (Byte_RX == ENQ)
       {
        Byte_TX = ACK;
        write(fd,&Byte_TX,1);
       }
    else
       {
        erro = TRUE;
        errnum = 4;
       }
   }

/* FASE 2 RECEPCAO DO TELEGRAMA DO ROBO */

if (erro == FALSE)
   {

