#include <stdio.h>
#include <fcntl.h>
#include <stdlib.h>
#include <termios.h>
#include <errno.h>
#include <time.h>

#define ENQ 0x05
#define ACK 0x06
#define WACK 0x0E
#define RVI 0x0F
#define NAK 0x15
#define DLE 0x10
#define STXeven 0x02
#define STXodd 0x82
#define ETX 0x03
#define EOT 0x04

#define BAUDRATE B9600
#define MODEMDEVICE "/dev/ttyS1"
#define TRUE 1
#define FALSE 0

char * cp;
char * empty = "<empty>";

main(int argc, char ** argv)
{
int fd, i;
struct termios oldtio, newtio, oldstdtio, newstdtio;
char Byte_TX, Byte_RX;
time_t TimeSec;

printf("Content-type: text/html\n\n");
printf("<HTML><title></title><body
background=\"http://webrobot.graco.unb.br/~paulinyi/figuras/circuit.gif\"
bgcolor=\"#ffffff\"
text=\"#000000\">");
#define safenv(a) ((cp = getenv(a)) ? cp : empty)

fd = open(MODEMDEVICE, O_RDWR | O_NOCTTY);
if (fd<0)
   {
    perror(MODEMDEVICE);
    exit(-1);
   }   

tcgetattr(fd,&oldtio);
newtio.c_cflag = BAUDRATE | CRTSCTS | CS8 | PARENB | CLOCAL | CREAD;
newtio.c_iflag = IGNPAR;
newtio.c_oflag = 0;
newtio.c_lflag = 0;
newtio.c_cc[VMIN]=1;
newtio.c_cc[VTIME]=0;   
tcflush(fd,TCIFLUSH);
tcsetattr(fd,TCSANOW,&newtio);
tcsetattr(1,TCSANOW,&newtio);
tcgetattr(0,&oldstdtio);
tcgetattr(0,&newstdtio);
newstdtio.c_lflag &= ~(ICANON | ECHO);
tcsetattr(0,TCSANOW,&newstdtio);

/* FASE 1 TRANSMISSAO */

Byte_TX= ENQ;
write(fd,&Byte_TX,1);
TimeSec = time(NULL);

if ((time(NULL) - TimeSec >= 3) || (read(fd,&Byte_RX,1)>0))

if (Byte_RX == ACK) 
   {
    printf("<img
src=\"http://webrobot.graco.unb.br/~paulinyi/grnball.gif\">");
    printf("Robo ON");
   }
else printf("<img
src=\"http://webrobot.graco.unb.br/~paulinyi/redball.gif\"> Robo
Fora de Funcionamento");
}
