#include <stdio.h>
#include <stdlib.h>
#include <iostream.h> 

#include "nomad.h"
#include "senir.h" 


int main(int argc, char *argv[])
{

	Nomad nomad;
	SenIr senIr;
	
	cout << "Conectando com o Robo" << endl;
	if (nomad.Connect() == N_NO_ERROR)
		cout << "Conexo OK" << endl;
	else
		cout << "Erro ao Conectar com o Robo"  << endl;

	nomad.Speak("Conectado!");
	
	Sensor ir;
	
	for (int k=0; k < 6 ; k++ )
	{
		if ( senIr.Start() == N_NO_ERROR )
			cout << "Conjunto " << k << " inicializado" << endl;
		else
			cout << "Conjunto " << k << " erro de inicializacao" << endl;
	

		ir.set = k;
		cout << "*********************************************" << endl;
		cout << "              Conjunto: " << k << endl;

		for (int i=0; i < 8 ; i++) 
		{
			ir.id = i;	
			cout << i << " - " << senIr.Read(ir) << endl;
		}		
	}
	
	// Disconectando

	if (nomad.Disconnect() == N_NO_ERROR)
		cout << "Desconexo OK" << endl;
	else
		cout << "Erro ao Desconectar-se do Robo"  << endl;
	
}
