#include <stdio.h>
#include <stdlib.h>
#include <iostream.h>

#include "nomad.h"
#include "util.h"
#include "cinematic.h"


int main(int argc, char *argv[])
{

	Nomad nomad;
	Coord pos, vel, acc, posInicial, posFinal;
	Cinematic cinematic;
    char mode = 0;


	mode = N_AXIS_POSITION_RELATIVE;

    //mode = N_AXIS_POSITION_ABSOLUTE;
               

	cout << "Conectando com o Robo" << endl;
	if (nomad.Connect() == N_NO_ERROR)
		cout << "Conexo OK" << endl;
	else
		cout << "Erro ao Conectar com o Robo"  << endl;

	nomad.Speak("Conectado!");

        	
	vel.x 	= 800;
	vel.y 	= 800; //mm/s
	vel.rot	= 800;

	acc.x	= 80;
	acc.y	= 80;  //mm/s/s
	acc.rot	= 80;

   	Coord zero;
	zero.x = zero.y = zero.rot = 0;
	
	cinematic.SetVelocity(vel);
	cinematic.SetAccel(acc);
	
	for (int i=0 ; i < 3 ;i++ )
	{
		
		cinematic.SetOdometry(zero);

		pos.x	= -1000;
		pos.y 	= 0;
		pos.rot	= 0;

		posInicial = cinematic.GetPosition();
		posFinal.x   = posInicial.x + pos.x;
		posFinal.y   = posInicial.y + pos.y;
		posFinal.rot = posInicial.rot + pos.rot;
		
		cinematic.SetPosition(pos, mode);

	   while(cinematic.Moving())
		{
					//cout << "Posicao Atual: (" << cinematic.GetPosition().x << "," << cinematic.GetPosition().y << "," << cinematic.GetPosition().rot << ")" << endl;
					//cout << "Odometro:      (" << cinematic.GetOdometry().x << "," << cinematic.GetOdometry().y << "," << cinematic.GetOdometry().rot << ")" << endl;
		}


		pos.x	= 0;
		pos.y 	= 2000;
		pos.rot	= 0;

		posInicial = cinematic.GetPosition();
		posFinal.x   = posInicial.x + pos.x;
		posFinal.y   = posInicial.y + pos.y;
		posFinal.rot = posInicial.rot + pos.rot;
		
		cinematic.SetPosition(pos, mode);
	   while(cinematic.Moving())
		{
					//cout << "Posicao Atual: (" << cinematic.GetPosition().x << "," << cinematic.GetPosition().y << "," << cinematic.GetPosition().rot << ")" << endl;
					//cout << "Odometro:      (" << cinematic.GetOdometry().x << "," << cinematic.GetOdometry().y << "," << cinematic.GetOdometry().rot << ")" << endl;
		}

		pos.x	= 2000;
		pos.y 	= 0;
		pos.rot	= 0;

		posInicial = cinematic.GetPosition();
		posFinal.x   = posInicial.x + pos.x;
		posFinal.y   = posInicial.y + pos.y;
		posFinal.rot = posInicial.rot + pos.rot;
		
		cinematic.SetPosition(pos, mode);

	   while(cinematic.Moving())
		{
					//cout << "Posicao Atual: (" << cinematic.GetPosition().x << "," << cinematic.GetPosition().y << "," << cinematic.GetPosition().rot << ")" << endl;
					//cout << "Odometro:      (" << cinematic.GetOdometry().x << "," << cinematic.GetOdometry().y << "," << cinematic.GetOdometry().rot << ")" << endl;
		}

		pos.x	= 0;
		pos.y 	= -2000;
		pos.rot	= 0;

		posInicial = cinematic.GetPosition();
		posFinal.x   = posInicial.x + pos.x;
		posFinal.y   = posInicial.y + pos.y;
		posFinal.rot = posInicial.rot + pos.rot;
		
		cinematic.SetPosition(pos, mode);

	   while(cinematic.Moving())
		{
					//cout << "Posicao Atual: (" << cinematic.GetPosition().x << "," << cinematic.GetPosition().y << "," << cinematic.GetPosition().rot << ")" << endl;
					//cout << "Odometro:      (" << cinematic.GetOdometry().x << "," << cinematic.GetOdometry().y << "," << cinematic.GetOdometry().rot << ")" << endl;
		}

		
		pos.x	= -1000;
		pos.y 	= 0;
		pos.rot	= 0;

		posInicial = cinematic.GetPosition();
		posFinal.x   = posInicial.x + pos.x;
		posFinal.y   = posInicial.y + pos.y;
		posFinal.rot = posInicial.rot + pos.rot;
		
		cinematic.SetPosition(pos, mode);

	   while(cinematic.Moving())
		{
					 
		}
				
		cout << "volta n:  "<<i+1 <<endl;
		cout << "Posicao Atual: (" << cinematic.GetPosition().x << "," << cinematic.GetPosition().y << "," << cinematic.GetPosition().rot << ")" << endl;
		cout << "Odometro:      (" << cinematic.GetOdometry().x << "," << cinematic.GetOdometry().y << "," << cinematic.GetOdometry().rot << ")" << endl;
	
	
	}

	/*if (posFinal.x != cinematic.GetPosition().x)
	{
		cout << "Erro na posicao X" << endl;
		cout << "posFinal = " << posFinal.x << endl;
		cout << "posAtual = " << cinematic.GetPosition().x << endl;
	}


	if (posFinal.y != cinematic.GetPosition().y)
	{
		cout << "Erro na posicao Y" << endl;
		cout << "posFinal = " << posFinal.y << endl;
		cout << "posAtual = " << cinematic.GetPosition().y << endl;
	}

	if (posFinal.rot != cinematic.GetPosition().rot)
	{
		cout << "Erro na Rotacao" << endl;
		cout << "posFinal = " << posFinal.rot << endl;
		cout << "posAtual = " << cinematic.GetPosition().rot << endl;
	}*/


   	if (nomad.Disconnect() == N_NO_ERROR)
		cout << "Desconexo OK" << endl;
	else
		cout << "Erro ao Desconectar-se do Robo"  << endl;

}


