#ifndef CINEMATIC_H
#define CINEMATIC_H

#include "util.h"
#include "Nclient.h"

class Cinematic
{
	public:
		Cinematic();
		~Cinematic();

		bool Moving(N_RobotState *state);
		int SetOdometry(N_RobotState *state, Coord coord);
		Coord GetOdometry(N_RobotState *state);
		Coord GetVelocity(N_RobotState *state);
		Coord GetAccel(N_RobotState *state);
		Coord GetPosition(N_RobotState *state);
		void SetPosition(N_RobotState *state, Coord pos, char mode);
		void SetPosition(N_RobotState *state, Coord pos, Coord vel, Coord acc, char mode);
		void SetVelocity(N_RobotState *state,Coord vel);
		void SetAccel(N_RobotState *state,Coord acc);
		void ZeroRobot(N_RobotState *state);

	private:
		bool global_ref;


};

#endif


