package navmap;

/**
 * <p>Title: NavMap</p>
 * <p>Description: Navegao por Mapeamento</p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: Graco - UnB</p>
 * @author Paulo Roberto Correa Dutra & Marcio Moreira de Sousa
 * @version 1.0
 */

public class CntrPainelInfo {

  /*
   * Referencia para o Conector Java
   */
  ConectorJava conector;

  /**
   * Construtor pega a instancia do Conector Java-C++
   */
  public CntrPainelInfo() {
    conector = conector.getInstance();
  }

  /**
   * Mtodo para iniciar o Nomad
   */
  public void Conectar(){
    conector.startNomad();
  }


  /**
   * Mtodo para finalizar o Nomad
   */
  public void Desconectar(){
    conector.finishNomad();
  }

  /**
   * Mtodo para pegar o status das baterias
   * @return Matriz de float com os valores das tenses das 4 baterias
   */
  public float[] getBatteryStatus(){
    return conector.getBatteryStatus();
  }
}