#include <stdio.h>
#include <fcntl.h>
#include <stdlib.h>
#include <termios.h>
#include <errno.h>
#include <time.h>

#define ENQ 0x40
#define ACK 0x40
#define STX 0x40
#define ETX 0x21
#define EOT 0x21

#define BAUDRATE B4800
#define MODEMDEVICE "/dev/ttyS1"
#define TRUE 1
#define FALSE 0

main()
{

int fd, NOB, i, prog;
struct termios oldtio, newtio, oldstdtio, newstdtio;
char Byte_TX, Byte_RX[7], contato, BCS, T;
unsigned char Telegram_TX[6];
time_t TimeSec;

printf("abrindo device serial\n");

fd = open(MODEMDEVICE, O_RDWR | O_NOCTTY | O_NDELAY);
if (fd<0)
   {
    perror(MODEMDEVICE);
    exit(-1);
   }   
/* BAUDRATE | CRTSCTS | CS7 | PARENB | CLOCAL | CREAD; */
tcgetattr(fd,&oldtio);
newtio.c_cflag = BAUDRATE | CS7 | PARENB | CLOCAL | CREAD;
newtio.c_iflag = IGNPAR | ICRNL;
newtio.c_oflag = 0;
newtio.c_lflag = 0;
newtio.c_cc[VMIN]=1;
newtio.c_cc[VTIME]=0;   
tcflush(fd,TCIFLUSH);
tcsetattr(fd,TCSANOW,&newtio);

/* FASE 1 TRANSMISSAO */

printf("Iniciando transmissao\n");

Byte_TX = ENQ;
write(fd,"@04s!",4);

printf("transmissao efetuada - @ deve ecoar para PC ler\n");

/* DEFININDO O TELEGRAMA A SER TRANSMITIDO */

Telegram_TX[0]=0x0; 
Telegram_TX[1]=0x01;
Telegram_TX[2]=0x54;
Telegram_TX[3]=0x06;
Telegram_TX[4]=0x07;
Telegram_TX[5]=0x21;

/* FASE 2 TRANSMISSAO */

NOB = write(fd,"@4s!",4);
if (NOB < 0)
	fputs ("write() 15 bytes falha!\n", stderr); 
printf("Telegrama enviado - Concluido\n");

read(fd,&Byte_RX,5);
printf("byte recebido %s\n",Byte_RX);  

close (fd);

}
