#include <stdio.h>
#include <fcntl.h>
#include <stdlib.h>
#include <termios.h>
#include <errno.h>
#include <time.h>
#include <asm/io.h>

#define _POSIX_SOURCE 1 /* POSIX compliant source */
#define BAUDRATE B4800
#define MODEMDEVICE "/dev/ttyS1"
#define TRUE 1
#define FALSE 0

volatile int STOP=FALSE;

main()
{

int fd, NOB, i, prog, k, res, n=0;
struct termios oldtio, newtio;
char st[7], buf[255], men[100], ST[10];

/* time_t TimeSec; */

fd = open(MODEMDEVICE, O_RDWR | O_NOCTTY | O_NDELAY);
if (fd<0)
   {
    perror(MODEMDEVICE);
    exit(-1);
   }   
/* BAUDRATE | CRTSCTS | CS7 | PARENB | CLOCAL | CREAD; */
tcgetattr(fd,&oldtio); /* save current serial port settings */
bzero(&newtio, sizeof(newtio)); /* clear struct for new port settings */
newtio.c_cflag = BAUDRATE | CS7 | CLOCAL | CREAD | PARENB; 
newtio.c_iflag = IGNPAR | ICRNL; 
newtio.c_oflag = 0;
newtio.c_lflag = 0; 

/* Para entrada de dados Non Canonical comentar as duas linhas seguintes */

/* newtio.c_cc[VMIN]=7; */  /* blocking read until 5 chars received */
/* newtio.c_cc[VTIME]=0; */  /* inter-character timer unused */


tcflush(fd,TCIFLUSH);
/* tcsetattr(fd,TCSANOW,&newtio); */


/* FASE 2 TRANSMISSAO */

write(fd,"@01T83!",7); 
/*
sleep(1);
ioperm (0x02f8,1,1);

st[1]=inb(0x02f8);
st[2]=inb(0x02f8);
st[3]=inb(0x02f8);
st[3]=inb(0x02f8);
st[4]=inb(0x02f8);
st[5]=inb(0x02f8);
st[6]=inb(0x02f8);
st[7]=inb(0x02f8);

printf("Status:%s\n",st);


k=ioperm(fd,buf,1);
if (k<0)
printf("ioperm failed : %d\n",k, buf,fd); 

if (k<0)
   {
    perror(MODEMDEVICE);
    exit(-1);
    }

*/
sleep (2);	
i = read(fd, men, 11);

if (fd<0)
   {
    perror(MODEMDEVICE);
    exit(-1);
    }

printf("o valor de i: %d\n",i);
if (i <=0)
printf("read() of 7 bytes failed! - %s\n", strerror(errno)); 
printf("o que foi lido: %s !\n",men);
close(fd);
printf("o valor de fd e: %d \n",fd);
return (fd);

/* restore the old port settings */
tcsetattr(fd,TCSANOW,&oldtio); 

close(fd);
}
