#include <stdio.h>
#include <fcntl.h>
#include <stdlib.h>
#include <termios.h>
#include <errno.h>
#include <time.h>

#define ENQ 0x40
#define ACK 0x40
#define STX 0x40
#define ETX 0x21
#define EOT 0x21

#define BAUDRATE B9600
#define MODEMDEVICE "/dev/ttyS1"
#define TRUE 1
#define FALSE 0

main()
{

int fd, NOB, i, prog;
struct termios oldtio, newtio, oldstdtio, newstdtio;
char Byte_TX, Byte_RX, contato, BCS, T;
unsigned char Telegram_TX[6];
time_t TimeSec;

printf("abrindo device serial\n");

fd = open(MODEMDEVICE, O_RDWR | O_NOCTTY);
if (fd<0)
   {
    perror(MODEMDEVICE);
    exit(-1);
   }   

tcgetattr(fd,&oldtio);
newtio.c_cflag = BAUDRATE | CRTSCTS | CS7 | PARENB | CLOCAL | CREAD | CSTOPB;
newtio.c_iflag = IGNPAR;
newtio.c_oflag = 0;
newtio.c_lflag = 0;
newtio.c_cc[VMIN]=1;
newtio.c_cc[VTIME]=0;   
tcflush(fd,TCIFLUSH);
tcsetattr(fd,TCSANOW,&newtio);
tcsetattr(1,TCSANOW,&newtio);
tcgetattr(0,&oldstdtio);
tcgetattr(0,&newstdtio);
newstdtio.c_lflag &= ~(ICANON | ECHO);
tcsetattr(0,TCSANOW,&newstdtio);

/* FASE 1 TRANSMISSAO */

printf("Iniciando transmissao\n");

Byte_TX= ENQ;
write(fd,&Byte_TX,1);


printf("transmissao efetuada   -   @  deve ecoar para PC ler\n");

/*
read(fd,&Byte_RX,1);
printf("o byte recebido %d",Byte_RX);  */


/*
if (Byte_RX == ACK) contato = TRUE;
else if (Byte_RX == ENQ)
       { 
        read(fd,&Byte_RX,1);
        if (Byte_RX == ACK) contato = TRUE;
        else contato = FALSE;
       }
     else contato = FALSE;
*/
/* DEFININDO O TELEGRAMA A SER TRANSMITIDO */

Telegram_TX[0]=0x0; 
Telegram_TX[1]=0x01;
Telegram_TX[2]=0x54;
Telegram_TX[3]=0x06;
Telegram_TX[4]=0x07;
Telegram_TX[5]=0x21;

/* FASE 2 TRANSMISSAO */

NOB = 6;
for(i=0;i<NOB;i++)
   {
    write(fd,&Telegram_TX[i],1);
    printf("Telegrama Sendo enviado, i, Telegram_TX[i]\n");
   }
/*
read(fd,&Byte_RX,1);
printf("o byte recebido %d",Byte_RX);
if (Byte_RX == ACK) contato = TRUE;
if (Byte_RX != ACK) contato = FALSE;

if (contato == TRUE) 
   {   
    printf("CONTATO OK! \n");
    Byte_TX = EOT;
    write(fd,&Byte_TX,1);
   }
else printf("SEM CONTATO! \n");
*/

printf("Telegrama enviado - Concluido\n");

/* FASE 1 RECEPCAO 

printf("esperando ENQ do ROBO\n");
read(fd,&Byte_RX,1);
printf("ENQ do ROBO recebido\n");
printf("o byte recebido %d",Byte_RX);

if (Byte_RX == ENQ)
   {
    Byte_TX = ACK;
    write(fd,&Byte_TX,1);
   }
else contato = FALSE;

read(fd,&Byte_RX,1);
if (Byte_RX == DLE) read(fd,&Byte_RX,1);

BCS = 0;

for(i=0;i<62;i++)
   {
    read(fd,&Telegram_RX[i],1);
    if (Telegram_RX[i] == DLE) read(fd,&Byte_RX,1);
   }

read(fd,&Byte_RX,1);
read(fd,&Byte_RX,1);
read(fd,&Byte_RX,1);
     
Byte_TX = ACK;
write(fd,&Byte_TX,1);

read(fd,&Byte_RX,1);
system("reset");
for(i=0;i<62;i++) printf("Telegrama[%d] = %d\n",i,Telegram_RX[i]);

prog=Telegram_RX[12]*0x100+Telegram_RX[13];
printf("Prog#: %d\n",prog);

ins=Telegram_RX[14]*0x100+Telegram_RX[15];
printf("Instruction#: %d\n",ins);
printf("Frame: %d\n",Telegram_RX[16]);
printf("TCP: %d\n",Telegram_RX[17]);

i=Telegram_RX[18]/16;
i=Telegram_RX[18]-(i*16); /* numero obtido referente aos 4 primeiros bits

keym = i/8;
if (keym>0) printf("Key Mode: TEACH\n");
else printf("Key Mode: AUTO\n");

i=i-(keym*16);

opm= i/4;
i=i-(opm*4);

opm= i/2;
if (opm>0) printf("Program Under Execution\n");
i=1-(opm*2);
if (i=0) printf("Stand by\n");
else printf("Operation\n");
*/ 

}
