//<APPLET CODE=principal6.class width=200 height=100></APPLET>

import java.awt.*;
import java.awt.event.*;
import java.applet.Applet;
import java.net.*;
import java.io.*;
import java.lang.*;

public class principal6 extends java.applet.Applet {

static String[]
 stringButtons ={"START","CE","STOP","BloqCNC","Modo Manual","LibCNC","Zerar X","Referenciar","Zerar Y","Enviar Programa","Exec. Continua","Selecionar Programa","Status","Backup","EMERGENCIA !!!"};

Button 
 botaoenv, botaoexec, botbackup;

Button[]
 controlButtons = new Button [16];

Panel
   family,
   principal,
   enviar,
   executar,
   backup,
   master;

CardLayout card = new CardLayout();

Label
   controlLabel,
   StatusBackup = new Label ("Aguarde...");

SocketIO
   connection;

TextField[]
   setupText = new TextField[1]; 

TextField
   texto;

TextArea
   areatexto,
   areabackup;	

String sbackup="";

public void init( ) {

	controlLabel = new Label ("Conectando com o servidor...");
	
	try {
	   connection = new SocketIO (getCodeBase().getHost(),8088);
	   connection.send ("teste remoto");
	   controlLabel.setText ("Conectado ao servidor.");
	}
	catch (UnknownHostException e) {
	   System.err.println ("Erro na URL do servidor.");
	   controlLabel.setText ("Erro na URL do servidor.");
	}
	catch (IOException e) {
	   e.printStackTrace ();
	   System.err.println ("Erro ao conectar servidor.");
	   controlLabel.setText ("Erro ao conectar servidor.");
	}


	int current = 0;

	int i;

	principal = new Panel(new BorderLayout (2,2));
	family = new Panel (new GridLayout(5,3,1,1));

	for (i=0;i<15;i++) {
		controlButtons [i] = new Button (stringButtons[i]);
		controlButtons[i].addActionListener (new EventButton (i));
		family.add (controlButtons [i]);
	}

	principal.add (family,BorderLayout.CENTER);
	principal.add (controlLabel,BorderLayout.SOUTH);
	
 	enviar = new Panel (new BorderLayout (3,1));
	enviar.add (new Label("Edite ou cole o Programa a enviar no campo abaixo."),BorderLayout.NORTH);
	areatexto = new TextArea (10,40);
 	enviar.add (areatexto, BorderLayout.CENTER);
	botaoenv = new Button ("ENVIAR PROGRAMA");
	enviar.add (botaoenv, BorderLayout.SOUTH);
	botaoenv.addActionListener (new EnvButton());

	executar = new Panel (new BorderLayout (3,1));
        executar.add (new Label("Digite o Nmero do programa a selecionar."),BorderLayout.NORTH);
        texto = new TextField (4);
	executar.add (texto, BorderLayout.CENTER);
        botaoexec = new Button ("SELECIONAR PROGRAMA");
	executar.add (botaoexec, BorderLayout.SOUTH);
	botaoexec.addActionListener (new ExecButton());   	

	backup = new Panel (new BorderLayout (3,1));
	backup.add (StatusBackup ,BorderLayout.NORTH);
	areabackup = new TextArea (sbackup,130,130);
	backup.add (areabackup, BorderLayout.CENTER);
	botbackup = new Button ("VOLTAR");
	backup.add (botbackup, BorderLayout.SOUTH);
	botbackup.addActionListener (new VoltButton()); 	

	master = new Panel (card);
	
	master.add (principal,"principal");
	master.add (enviar,"enviar");
	master.add (executar,"executar");
	master.add (backup, "backup");
	card.show(master, "principal");

	setLayout (new GridLayout(1,1));
	add (master);

}

public void destroy () {
	try {
		connection.send ("bye");
		connection.close();
	}
	catch (IOException e) {
		System.err.println ("Erro com o servidor");
	}
}	


class EventButton implements ActionListener {

	int index;
	String status ="",lido="";

	EventButton (int index) {
	  this.index = index;
	}

	public void actionPerformed (ActionEvent e){
	String command="";

	switch (index) {
	   case 0:
		command = "start";
	   	break;
	   case 1:
		command = "CE";
		break;
	   case 2: 
		command = "stop";
		break;
	   case 3:
		command = "bloqcnc";
		break;
	   case 4:
		command = "manual";
		break;
	   case 5:
		command = "libcnc";
		break;
	   case 6:
		command = "zeroX";
		break;
	   case 7:
		command = "ref";
		break;
	   case 8:
		command = "zeroY";
		break;
	   case 9:
		card.show (master, "enviar");
		break;
	   case 10:
		command = "execcont";
		break;
	   case 11:
		command = "selec";
		try {
           	connection.send (command);
           	Thread.sleep (1500);
           	status = connection.get ();
           	System.out.println (command);
              	}                              
		catch (Exception exception) {
           	controlLabel.setText ("Erro: Servidor em uso.");
           	exception. printStackTrace();
           	}                            
		card.show (master, "executar");
		break;
	   case 12:
		command = "status";
		break;
	   case 13:
		command = "backup";
		card.show (master, "backup");
		try {
		connection.send (command);
        	Thread.sleep (4000);
		lido = connection.get();
		while (lido != "") {
			sbackup = sbackup + lido;
        		lido = connection.get();}
		}
        	catch (Exception exception){
        	controlLabel.setText ("Erro: Servidor em uso.");
        	exception. printStackTrace();}
		StatusBackup.setText ("Programas existentes na mquina.");
        	areabackup.setText(sbackup);                                
		break;

	   case 14:
		command = "emergencia";
		break;
	}
	 
	   if ((index != 9) && (index != 11) && (index != 13))  
	   try {
	   connection.send (command);
	   Thread.sleep (1500);
	   status = connection.get ();
	   System.out.println (command);
	      }
	   catch (Exception exception) {
	   controlLabel.setText ("Erro: Servidor em uso.");
	   exception. printStackTrace();
	   }
	   	
	   controlLabel.setText (status);
	}
}

class ExecButton implements ActionListener {

	public void actionPerformed (ActionEvent e){
	String command="ent",status1="";

	   try {
	   connection.send (texto.getText()+command);
	   Thread.sleep (1500);
	   status1 = connection.get ();
	   System.out.println (command);
	   }
	   catch (Exception exception) {
	   controlLabel.setText ("Erro: Servidor em uso.");
	   exception. printStackTrace();
	   }

	controlLabel.setText (status1);
	
	card.show (master, "principal");
}
		
}

class EnvButton implements ActionListener {

	public void actionPerformed (ActionEvent e){
	String command="",status2="";

	   try {
	   connection.send (areatexto.getText());
	   Thread.sleep (2000);
	   status2 = connection.get ();
	   System.out.println (command);
	   }
	   catch (Exception exception) {
	   controlLabel.setText ("Erro: Servidor em uso.");
	   exception. printStackTrace();
	   }

	controlLabel.setText (status2);
	
	card.show (master, "principal");
}
		
}

class VoltButton implements ActionListener {
	
	public void actionPerformed (ActionEvent e){
	 card.show (master, "principal");}
}
}
