#ifndef CINEMATIC_H
#define CINEMATIC_H

#include "util.h"
#include "senbumper.h"
#include "Nclient.h"
class Cinematic
{
	public:
		Cinematic();
		~Cinematic();

		bool Moving(N_RobotState *state);
		Coord GetOdometry(N_RobotState *state);
		Coord GetVelocity(N_RobotState *state);
		Coord GetAccel(N_RobotState *state);
		Coord GetPosition(N_RobotState *state);
		int  SetOdometry(N_RobotState *state, Coord coord);
		void SetPosition(N_RobotState *state, Coord pos, Coord vel, Coord acc, char mode);
		void Stop(N_RobotState *state);
		void ZeroRobot(N_RobotState *state);
		SenBumper bumper;

	private:
		bool global_ref;


};

#endif


