#include <termios.h>
#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/signal.h>
#include <string.h>
#include <stdlib.h>
#include <errno.h>

#define BAUDRATE B9600
#define MODEMDEVICE "/dev/ttyS1"

main (int argc, char ** argv)
{
int fd, i, a, c;
char prog[30];
struct termios oldtio, newtio, oldstdtio, newstdtio;

/* inicio do documento HTML */

printf("Content-type: text/html \n\n");
printf("<HTML><title>DEMONSTRACAO</title><h1>");
printf("<body bgcolor=\"#0000ff\"><h4>Programa Para Recebimento de Dados
via RS-232<br>");


/* abertura da porta de comunicacao */
 
fd = open(MODEMDEVICE, O_RDWR | O_NOCTTY);
if (fd < 0) 
{
 perror(MODEMDEVICE);
 exit(-1);
}
printf("porta serial aberta<br>");

/* definindo parametros de comunicacao */

tcgetattr(fd,&oldtio);
newtio.c_cflag = BAUDRATE | CRTSCTS | CS8 | CLOCAL | CREAD;
newtio.c_iflag = IGNPAR;
newtio.c_oflag = 0;
newtio.c_lflag = 0;
newtio.c_cc[VMIN]=1;
newtio.c_cc[VTIME]=0;
tcflush(fd, TCIFLUSH);
tcsetattr(fd,TCSANOW,&newtio);
tcsetattr(1,TCSANOW,&newtio);
tcgetattr(0,&oldstdtio);
tcgetattr(0,&newstdtio);
newstdtio.c_lflag &= ~(ICANON | ECHO);
tcsetattr(0,TCSANOW,&newstdtio);

a='a';
write(fd,&a,1);

for (i=1;i<130;i++) 
   {
    read(fd,&a,1);
    printf("%c",a);
   }

printf("<hr>Fim da transmissao!");
tcsetattr(fd,TCSANOW,&oldtio);
tcsetattr(0,TCSANOW,&oldstdtio);
close(fd);
}
