#include <termios.h>
#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/signal.h>
#include <string.h>
#include <stdlib.h>
#include <errno.h>

#define BAUDRATE B9600
#define MODEMDEVICE "/dev/ttyS1"
#define ENDMINITERM 2
#define _POSIX_SOURCE 1
#define FALSE 0
#define TRUE 1

char *cp;
char *empty = "<empty>";
volatile int STOP=FALSE;

void clild_handler(int s)
{
   STOP=TRUE;
}

main (int argc, char ** argv)
{
int fd, i, a, c;
char prog[30];
struct termios oldtio, newtio, oldstdtio, newstdtio;
struct sigaction sa;


/* inicio do documento HTML */

printf("Content-type: text/html \n\n");
printf("<HTML><title>Comunicacao Serial via HTML</title>");
printf("<center><h2><img src=figura1><br>Programa Teste para envio de
Dados via RS-232");


/* abertura da porta de comunicacao */
 
fd = open(MODEMDEVICE, O_RDWR | O_NOCTTY);
if (fd < 0) 
{
 perror(MODEMDEVICE);
 exit(-1);
}


/* definindo parametros de comunicacao */

tcgetattr(fd,&oldtio);
newtio.c_cflag = BAUDRATE | CRTSCTS | CS8 | CLOCAL | CREAD;
newtio.c_iflag = IGNPAR;
newtio.c_oflag = 0;
newtio.c_lflag = 0;
newtio.c_cc[VMIN]=1;
newtio.c_cc[VTIME]=0;
tcflush(fd, TCIFLUSH);
tcsetattr(fd,TCSANOW,&newtio);
tcsetattr(1,TCSANOW,&newtio);
tcgetattr(0,&oldstdtio);
tcgetattr(0,&newstdtio);
newstdtio.c_lflag &= ~(ICANON | ECHO);
tcsetattr(0,TCSANOW,&newstdtio);

/* leitura das variaveis da HOMEPAGE */

#define safenv(a) ((cp=getenv(a)) ? cp:empty)
 
strcpy(prog,safenv("QUERY_STRING"));
write(fd,prog,20);
tcsetattr(fd,TCSANOW,&oldtio);
tcsetattr(0,TCSANOW,&oldstdtio);
close(fd);
}
