#ifndef SEMA_H
#define SEMA_H

#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/sem.h>
#include <stdio.h>
#include <errno.h>
#include <string.h>
#include <unistd.h>
#include <signal.h>

#define CHAVE_SEM 0x1332
#define PERMISSOES_SEM 0x1FF //everybody


extern struct sembuf operacao[2];

extern int p_sem(int idsem);

extern int v_sem(int idsem);

extern int sem;


#define ENTER_CRITICALSECTION p_sem(sem)
#define LEAVE_CRITICALSECTION v_sem(sem)
#define GET_SEMAPHORE sem = semget(CHAVE_SEM, 1, PERMISSOES_SEM)

#define CREATE_SEMAPHORE sem = semget(CHAVE_SEM, 1, IPC_CREAT | PERMISSOES_SEM)
#define REMOVE_SEMAPHORE semctl(sem, 0, IPC_RMID, NULL)

#endif
