#ifndef TGetPosition_H
#define TGetPosition_H

#include "gxdlcode.h"
#include "gxthread.h"
#include "gxmutex.h"

#include "nomad.h"
#include "cinematic.h"

#include "sema.h"



class TGetPosition : public gxThread
{
public:

  TGetPosition(float* valores);
  ~TGetPosition();
  void setContinua(bool cont);
  void setPosition(int x, int y);

private: // Base class interface
  void *ThreadEntryRoutine(gxThread_t *thread);
  void ThreadExitRoutine(gxThread_t *thread);


  Nomad *nomad;
  Cinematic *cinematic;

  bool continua;
  long posx;
  long posy;
  
  float *posicoes;

};


#endif
