#include "header/movenomad.h"

int main(int* argc, char* argv)
{
	if (argc < 3)
	{
		printf("numero de argumentos invalidos"):
		return -1;
	}

	Nomad *nomad = new Nomad();
	Cinematic *cinematic = new Cinematic();
	struct N_RobotState *state;


	Coord goal;
	goal.x = atoi(argv[1]);
	goal.y = atoi(argv[2]);
	goal.rot = 0;

	// Setting the velocity[mm/s] and acceleration[mm/s^2]
	Coord vel, acc;
	vel.x = vel.y = vel.rot = acc.rot = 200;
	acc.x = acc.y = 400;


	if (nomad->Connect() != N_NO_ERROR)
	{
		printf("Erro ao conectar com o Nomad\n");
		return -1;
	}

	state = nomad->GetRobotState();

	cinematic->SetPosition(state, goal, vel, acc, N_AXIS_POSITION_RELATIVE);

	return 0;


}


