package navmap;

import javax.swing.*;
import java.awt.*;


/**
 * Barra de Status da Aplicaao NavMap
 * <p>Title: NavMap</p>
 * <p>Description: Navegao por Mapeamento</p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: Graco - UnB</p>
 * @author Marcio Moreira de Sousa e Paulo Roberto Corra Dutra
 * @version 1.0
 *
 *
 */

public class BarraStatus extends JPanel {
  private JLabel status = new JLabel();

  /**
   * Mtodo para configurar o texto que ser mostrado na barra de status
   * @param text Texto que ser moostrado na barra
   */
  public void SetStatusText(String text){
    status.setText(text);
    this.repaint();
  }

  public BarraStatus() {
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }
  private void jbInit() throws Exception {
    status.setBounds(new Rectangle(4, 3, 383, 17));
    this.setLayout(null);
    this.setBorder(BorderFactory.createLineBorder(Color.black));
    this.add(status, null);
  }
}