package navmap;

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;

import java.io.*;
import java.net.*;


/**
 * Classe Para parar o Robo em caso de Emergencia
 * <p>Title: NavMap</p>
 * <p>Description: Navegao por Mapeamento</p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: Graco - UnB</p>
 * @author Marcio Moreira de Sousa e Paulo Roberto Corra Dutra
 * @version 1.0
 */

public class Emergencia extends JFrame {
  private JPanel painelEmergencia = new JPanel();
  private JButton btEmergencia = new JButton();

  public Emergencia() {
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }


  }
  private void jbInit() throws Exception {
    this.getContentPane().setLayout(null);
    painelEmergencia.setBounds(new Rectangle(0, 0, 200, 100));
    painelEmergencia.setLayout(null);
    this.setResizable(false);
    btEmergencia.setBackground(Color.red);
    btEmergencia.setBounds(new Rectangle(7, 20, 186, 60));
    btEmergencia.setFont(new java.awt.Font("Dialog", 1, 12));
    btEmergencia.setForeground(Color.yellow);
    btEmergencia.setToolTipText("");
    btEmergencia.setText("Parada de Emergencia");
    btEmergencia.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        btEmergencia_actionPerformed(e);
      }
    });
    this.getContentPane().add(painelEmergencia, null);
    painelEmergencia.add(btEmergencia, null);
  }

  void btEmergencia_actionPerformed(ActionEvent e) {
    try{
      /* Abre a Conexao */
        Socket emergency = new Socket("164.41.17.12", 8090);

        JOptionPane.showMessageDialog(this, "NOMAD Parado", "Informao", JOptionPane.INFORMATION_MESSAGE);

       /* Fecha a Conexao */
        emergency.close();

    }catch(IOException ioe){
        JOptionPane.showMessageDialog(this, "Atenao Nao Consegui Parar o NOMAD", "PERIGO", JOptionPane.INFORMATION_MESSAGE);
        ioe.printStackTrace();
    }
  }

}