/*--------------------------------------------------------*/
/* Programa    : ADLP_10.H                                */
/* Funcao      : Computer Link ADLP 10 - PC versus IRB S3 */
/* Versao      : 1.0                                      */
/* Data        : Novembro/96                              */
/* Programador : Marcio Heidi Suguieda - GRACO/UnB        */
/* Compilador  : Borland C++ - Versao 3.1 - 1990-1992 (c) */
/* Linguagem   : C                                        */
/* Observacao  : ADLP = ABB DATA LINK PROTOCOL            */
/* -------------------------------------------------------*/

//#ifndef  __ADLP_10_H
//#define  __ADLP_10_H
//#endif

char InitCommPort(int CommPort);
  /* Se retorna  TRUE: porta serial inicializada com sucesso */
  /* Se retorna FALSE: falha na inicializacao da porta serial */
  /* Obs.: O = 'COM1' e 1 = 'COM2'; outras 'COMs' nao disponiveis */
//void CloseCommPort(int CommPort);
  /* Desabilita porta serial */
  /* Obs.: Deve ser usada ao termino do programa */
//void FlushCommPort(void);
  /* Limpa dados nos 'buffers' de entrada e saida da porta serial */
char DataReady(void);
  /* Se retorna  TRUE: ha dados disponiveis para leitura */
  /* Se retorna FALSE: nao ha dados disponiveis para leitura */
int SendTelegram(char* Telegram);
  /* Se retorna -2: erro na fase 2 ! */
  /* Se retorna -1: erro na fase 1 ! */
  /* Se retorna  0: telegrama enviado com a comunicacao concluida ! */
  /* Se retorna  1: telegrama enviado sem a comunicacao concluida ! */
int ReceiveTelegram(char* Telegram);
  /* Se retorna -3: erro na fase 3 ! */
  /* Se retorna -2: erro na fase 2 ! */
  /* Se retorna -1: erro na fase 1 ! */
  /* Se retorna  0: telegrama recebido com a comunicacao concluida ! */
  /* Se retorna  1: telegrama recebido sem a comunicacao concluida ! */
  /* Se retorna  2: repeticao de telegrama com a comunicacao concluida ! */
  /* Se retorna  3: repeticao de telegrama sem a comunicacao concluida ! */
  /* Se retorna  9: nenhum dado disponivel durante o tempo de 'time out' ! */
