#include <stdio.h>
#include <stdlib.h>
#include <iostream.h>

#include "nomad.h"
#include "sensonar.h"


int main(int argc, char *argv[])
{

	Nomad nomad;
	SenSonar senSonar;
	N_RobotState *state;
	
	cout << "Conectando com o Robo" << endl;
	if (nomad.Connect() == N_NO_ERROR)
		cout << "Conexo OK" << endl;
	else
		cout << "Erro ao Conectar com o Robo"  << endl;

	nomad.Speak("Conectado!");

	int fo[8];
	for (int i=0;i<8 ;i++ ) fo[i] = i;

   state = nomad.GetRobotState();
   
   for (int k=0; k < 6 ; k++ )
	{

		//cout << "*********************************************" << endl;
		if ( senSonar.Start(state,k, fo, 5) != N_NO_ERROR )
        		//cout << "       Conjunto " << k << " inicializado! " << endl;
		cout << " Erro de inicializacao no conjunto " << k << endl;
		

	}

	
long sonar[3][100];


for(int j=0;j<100;j++)
{
		 sonar[0][j] =  senSonar.Read(state,6);
 		 sonar[1][j] =  senSonar.Read(state,14);
 		 sonar[2][j] =  senSonar.Read(state,22);
}

for (int i=0;i<3 ;i++ )
{
	printf("sonar%d = [", i);
	for (int j=0;j<100 ;j++ )
	{
		printf("%d ", sonar[i][j]);
	}
	printf("];\n");
}


printf("medida = [ ");
for (int i=0; i<100 ;i++ )
{
	printf("%d ", i+1);
}
printf("];\n");

	// Disconectando

	senSonar.StopAll(state);

	if (nomad.Disconnect() == N_NO_ERROR)
		cout << "Desconexo OK" << endl;
	else
		cout << "Erro ao Desconectar-se do Robo"  << endl;

}
