#
# Makefile da Biblioteca de Conexao com o JAVA
#

CC=g++

# GCC 3.0.2
CFLAGS=-c -I/home/paulo/xrdev/include -I/u/jbuilder4/jdk1.3/include -Wno-deprecated

# GCC 2.95.2
# CFLAS=-c -I/home/paulo/xrdev/include -I/u/jbuilder4/jdk1.3/include

ROBOT_LIB=/home/paulo/xrdev/lib/Nhost_client.a

# GCC 3.0.2
EXTRA_LIB=-lm -shared

# GCC 2.95.2
# EXTRA_LIB=-lm -lshared

LOADLIBS=$(ROBOT_LIB) $(EXTRA_LIB)


lib_objects = nomad.o sensonar.o mapa.o makemap.o senbumper.o senir.o cinematic.o


all: libmakemap.so

libmakemap.so: $(lib_objects)
	$(CC) -o libmakemap.so $(lib_objects) $(LOADLIBS)

nomad.o : nomad.cpp
	$(CC) $(CFLAGS) nomad.cpp

senir.o : senir.cpp
	$(CC) $(CFLAGS) senir.cpp

senbumper.o: senbumper.cpp
	$(CC) $(CFLAGS) senbumper.cpp

sensonar.o: sensonar.cpp
	$(CC) $(CFLAGS) sensonar.cpp

mapa.o: mapa.cpp
	$(CC) $(CFLAGS) mapa.cpp

cinematic.o: cinematic.cpp
	$(CC) $(CFLAGS) cinematic.cpp

makemap.o	: makemap.cpp
	$(CC) $(CFLAGS) makemap.cpp




clean:
	rm -f *.o libMakeMap.so


