package navmap;

import javax.swing.JPanel;
import java.awt.Image;
import java.awt.image.*;


/**
 * <p>Title: NavMap</p>
 * <p>Description: Navegao por Mapeamento</p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: Graco - UnB</p>
 * @author unascribed
 * @version 1.0
 */

public class ImageMapa extends JPanel {

  public ImageMapa() {
  }

  public Image getImage() {
                      int w = 300;
                      int h = 300;
                      int pix[] = new int[w * h];
                      int index = 0;
                      for (int y = 0; y < h; y++) {
                          int red = (y * 255) / (h - 1);
                          for (int x = 0; x < w; x++) {
                                      int blue = (x * 255) / (w - 1);
                                      pix[index++] = (255 << 24) | (red << 16) | blue;
                          }
                      }
                      return createImage(new MemoryImageSource(w, h, pix, 0, w));

        }
}