package navmap;

import javax.swing.JPanel;
import javax.swing.*;
import java.awt.Graphics;
import java.awt.image.*;
import java.awt.*;






/**
 * <p>Title: NavMap</p>
 * <p>Description: Navegao por Mapeamento</p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: Graco - UnB</p>
 * @author unascribed
 * @version 1.0
 */

public class PainelBaterias extends JPanel implements Runnable{

  public PainelBaterias() {
    this.setBorder(BorderFactory.createLineBorder(Color.darkGray, 1));
  }


  public void paint(Graphics g){
    g.setColor(Color.blue);
    g.fillRect(0,0,50,50);

  }

  public void run(){
    while (true){
      try{
        Thread.sleep(1000);
        repaint();
      }catch(InterruptedException e){
        e.printStackTrace();
      }
    }
  }

  	public static void main(String[] args)
	{
		PainelBaterias pb = new PainelBaterias();
		pb.setSize(new Dimension(100,100));
		pb.show();
	}
}
