package navmap;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

/**
 * <p>Title: NavMap</p>
 * <p>Description: Navegao por Mapeamento</p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: Graco - UnB</p>
 * @author Paulo Roberto Correa Dutra & Marcio Moreira de Sousa
 * @version 1.0
 */

public class PainelInfo extends JPanel {
  private JButton btConectar    = new JButton("Conectar");
  private JButton btDesconectar = new JButton("Desconectar");
  private JLabel lbStatus   = new JLabel("Status do Nomad:");
  private JLabel lbBaterias = new JLabel("Baterias");


  public PainelInfo(ActionListener listener) {

    btConectar.setBounds(new Rectangle(42, 24, 111, 27));
    btConectar.addActionListener(listener);
    btDesconectar.setBounds(new Rectangle(41, 66, 110, 27));
    btDesconectar.addActionListener(listener);
    this.setLayout(null);
    this.setBorder(BorderFactory.createLineBorder(Color.darkGray, 1));
    lbStatus.setFont(new java.awt.Font("Serif", 1, 12));
    lbStatus.setForeground(Color.blue);
    lbStatus.setBounds(new Rectangle(14, 125, 115, 27));
    lbBaterias.setFont(new java.awt.Font("Serif", 1, 12));
    lbBaterias.setForeground(Color.blue);
    lbBaterias.setBounds(new Rectangle(17, 208, 71, 17));
    this.add(btDesconectar, null);
    this.add(btConectar, null);
    this.add(lbStatus, null);
    this.add(lbBaterias, null);
  }


}