#
# Makefile da Biblioteca de Conexao com o JAVA
#

CC=g++
CFLAGS=-c -I/home/paulo/xrdev/include -I/u/jbuilder4/jdk1.3/include -Wno-deprecated

ROBOT_LIB=/home/paulo/xrdev/lib/Nhost_client.a
EXTRA_LIB=-lm
LOADLIBS=$(ROBOT_LIB) $(EXTRA_LIB)


lib_objects = nomad.o sensonar.o mapa.o principal.o senbumper.o senir.o cinematic.o


all: principal

principal: $(lib_objects)
	$(CC) -o principal $(lib_objects) $(LOADLIBS)

nomad.o : nomad.cpp
	$(CC) $(CFLAGS) nomad.cpp

senir.o : senir.cpp
	$(CC) $(CFLAGS) senir.cpp

senbumper.o: senbumper.cpp
	$(CC) $(CFLAGS) senbumper.cpp

sensonar.o: sensonar.cpp
	$(CC) $(CFLAGS) sensonar.cpp

mapa.o: mapa.cpp
	$(CC) $(CFLAGS) mapa.cpp

cinematic.o: cinematic.cpp
	$(CC) $(CFLAGS) cinematic.cpp

principal.o	: principal.cpp
	$(CC) $(CFLAGS) principal.cpp




clean:
	rm -f *.o principal


