// <APPLET CODE=pantilt.class width=200 height=200></APPLET>

import java.awt.*;
import java.lang.*;
import java.awt.event.*;
import java.applet.Applet;
import java.net.*;
import java.io.*;
import java.lang.*;

//
// Main class for control of the camera of the pantilt
//


public class pantilt extends Applet {

static String[]
 stringButtons={"CE","ParaCima","CD","Esquerda","Direita","BE","ParaBaixo","BD","Mov.Rap.","Mov.Lento"},initSetup = {"5","5","0","0"};

	
// Verificar estes valores para o pantilt real
/*//////////////////////////////////////////////////////*/

Panel
  controlPanel,
  centerPanel;

Button[]
  controlButtons = new Button[10];

Label
  controlLabel;

URL
  server;

SocketIO
  connection;

int
  vel = 0;

boolean
  inUse = false;

// Init method for the applet. Initializes the applet and creates the panel and the
// buttons for its use.


public void init() {

  //setBackground(blue c);	

  controlLabel = new Label ("Connecting to server...");

  try {
  	connection = new SocketIO (getCodeBase().getHost(),8086);
	controlLabel.setText ("Server connected.");
  }
  catch (UnknownHostException e) {
	System.err.println ("Error in URL of camera server.");
	controlLabel.setText ("Error in URL of camera server.");
	inUse = true;
  }
  catch (IOException e) {
	System.err.println ("Error connecting camera server.");
	controlLabel.setText ("Error connecting camera server.");
	inUse = true;
  }


  controlPanel = new Panel (new GridLayout (5,3));

  int i;
  

  for (i=0;i<8;i++) {                   // creates all buttons
    controlButtons[i]=new Button (stringButtons[i]);
    controlButtons[i].addActionListener (new EventButton (i));

  }

  controlButtons[8]= new Button (stringButtons[8]);
  controlButtons[8].addActionListener (new EventButton (8));
  controlButtons[9]= new Button (stringButtons[9]);
  controlButtons[9].addActionListener (new EventButton (9));
  
  controlPanel.add (controlButtons[0]);
  controlPanel.add (controlButtons[1]);
  controlPanel.add (controlButtons[2]);  
  controlPanel.add (controlButtons[3]);
  controlPanel.add (new Label ("v1.1"));
  controlPanel.add (controlButtons[4]);
  controlPanel.add (controlButtons[5]);
  controlPanel.add (controlButtons[6]);
  controlPanel.add (controlButtons[7]);
  controlPanel.add (new Label (""));
  controlPanel.add (new Label ("     By Igor"));
  controlPanel.add (new Label ("& Joao"));
  controlPanel.add (new Label ("B & B"));
  controlPanel.add (controlButtons[8]);
  controlPanel.add (controlButtons[9]);
//  controlPanel.add (new Label (""));
//  controlPanel.add (new Label (""));
//  controlPanel.add (new Label (""));

  centerPanel = new Panel (new GridLayout (1,1));
  centerPanel.add (controlPanel);
  
//////////////////////////////////////////
//  setBackground (Color.red);
//  setForeground (Color.green);
//////////////////////////////////////////


  setLayout (new BorderLayout ());
  add (centerPanel,BorderLayout.CENTER);
  add (controlLabel,BorderLayout.SOUTH);

 
try {
        connection.send (" ");
          }
 
  catch (IOException e) {
        System.err.println ("Error : Server in use.");
        controlLabel.setText ("Error : Server in use.");
        inUse = true;
  }           

}
// Destroy method for the applet. Stops the socket connection with the servers.

public void destroy () {
  try {
	connection.send("bye");
  	connection.close();
  } catch (IOException e) {
	System.err.println ("Error closing connection with camera server.");
	controlLabel.setText ("Error closing connection.");
  }
}


// Class used to catch the events created by the buttons.

class EventButton implements ActionListener {

	int index;

  EventButton (int index) {
		this.index = index;
  }

  public void actionPerformed (ActionEvent e) {
	String command, pans, tilts;
	int i;
//	System.out.println(index);
	command="";
	switch (index) {
		case 0:	command="upleft";
			break;
		case 1: 
			command="up";
			break;
			
		case 2: 
			command="upright";
			break;
		case 3:
			command="left";
			break;
			
		case 4:
			command="right";
			break;
		
		case 5:
			command="downleft";
			break;
		case 6:
			command="down";
			break;
		case 7:
 			command="downright";
			break;
		case 8:
			vel=0;
			break;
		case 9:
			vel=1;
			break;
	}
	if(vel==1)
		{command+="1";
		}
	else
		{command+="";}
	
      	try {
        	connection.send (command);
      	}
      	catch(Exception exception) {
		controlLabel.setText ("Error: Server in use.");
		inUse = true;
		exception.printStackTrace();
      }
  }
}




} // end of applet
