#include <dos.h>

// Classe que define a interface com o motor
//
// Rotinas utilizadas pela classe Motor (motor.C)
//
// Este programa realiza a comunicao entre o programa motor.C e o
// sistema operacional DOS.


class Interface {

	private:

		int porta;

	public:
			Interface ();		// Construtor
		       ~Interface ();		// Destrutor
		void	send (int dado);	// Envia dado ao dispositivo
		void    waiting (int tempo);	// Espera o tempo definido

};

     Interface :: Interface ()

{
	porta = 0x0378;
	outportb (porta,0x01);		// direction set to logic 1 (?)
}

     Interface :: ~Interface ()

{
}

// As duas rotinas abaixo devem manter seu nome na versao para Linux.
// O conteudo evidentemente vai mudar...

void Interface :: send (int dado)

{
	outportb (porta,dado);
}

void Interface :: waiting (int tempo)

{
	delay (tempo);
}

